from shutil import which
from typing import List, Dict

from skip.managers.manager import PackageManager


# TODO
class Choco(PackageManager):
    @classmethod
    def remove(cls, packages: Dict[str, List[str]]) -> bool:
        pass

    @classmethod
    def install(cls, packages: Dict[str, List[str]]) -> bool:
        pass

    @classmethod
    def command(cls) -> List[str]:
        return "choco.exe".strip().split()

    @classmethod
    def canonical_name(cls) -> str:
        pass

    @classmethod
    def upgrade(cls) -> bool:
        pass

    @classmethod
    def clean(cls) -> bool:
        pass

    @classmethod
    def setup(cls):
        pass

    @classmethod
    def update(cls):
        pass

    @classmethod
    def check(cls) -> bool:
        from skip.managers.manager import OperatingSystem
        return cls.operating_system() in {OperatingSystem.Windows} and \
            which(cls.command()[0]) is not None
