from shutil import which

from skip.managers.brew import Brew


# TODO
class LinuxBrew(Brew):
    @classmethod
    def check(cls) -> bool:
        from skip.managers.manager import OperatingSystem
        return cls.operating_system() in {OperatingSystem.Linux} and \
            which(cls.command()[0]) is not None

    @classmethod
    def canonical_name(cls) -> str:
        return "linux-brew"
