from shutil import which

from skip.managers.brew import Brew


# TODO
class MacOSBrew(Brew):
    @classmethod
    def check(cls) -> bool:
        from skip.managers.manager import OperatingSystem
        return cls.operating_system() in {OperatingSystem.MacOS} and which(
            cls.command()[0]) is not None

    @classmethod
    def canonical_name(cls) -> str:
        return "macos-brew"
